//
#define DEBUG				1  // 32820 // prints debug info  
//
//
// Standard Omix is			   // 30717 bytes
#define PREFS				1  // 26447 // no "Preference panel"
#define RCFILE   			1  // 27558 // don't save/load 
//#define BUTTONS 			1  // 		
#define PICTURE 			1  // 23672 // don't use picture
#define EASYMOVE			1  //       // move by draging ?

/**********************************************************************
 *  Nothing to be changed below this line                             *
 *********************************************************************/
//#define BUTTONS 			1  // 	
#ifndef PICTURE  // we must have pictures if we use the "Preferences panel"
#ifdef PREFS
#define PICTURE 			1
#endif
#endif
#define TKM_RCFILE			"/.omixrc"
#define TKM_POLL_DEFAULT_INTERVAL	300
#define TKM_MIXER_DEVICE 		"/dev/mixer"
#define TKM_BUTTON_VIEWMENU		"View"
#define TKM_BUTTON_MAINMENU		"Sys"
#define TKM_MENU_VIEW_ONE               "View One"
#define TKM_MENU_VIEW_CUSTOM		"View Custom"
#define TKM_MENU_VIEW_LARGE		"View Large"
#define TKM_MENU_VIEW_ALL               "View All (Debug)"
#define TKM_MENU_VIEW_NEXT              "View Next"
#define TKM_MENU_TOGGLE_REC		"Show/Hide Record src"
#define TKM_MENU_TOGGLE_BAL		"Show/Hide Balance"
#define TKM_MENU_DISPLAY_LEFT_PANEL	"Show/Hide Menu Panel"
//#define TKM_MENU_VIEW_RESET_TO_DEFAULT	"View Reset"
#define TKM_MENU_QUIT			"Quit"
#define TKM_MENU_ABOUT			"About O'Mix"
#define TKM_MENU_POLL			"Enable/Disable Polling"
#define TKM_MENU_PREFERENCES		"Preferences"
#define TKM_MENU_SAVE			"Save Settings"
#define TKM_MENU_RECENTER_BALANCE	"Recenter Balance"
#define TKM_BUTTON_VIEW_ONE             "I"
#define TKM_BUTTON_VIEW_CUSTOM		"II"
#define TKM_BUTTON_VIEW_ALL		"III"
#define TKM_BUTTON_SAVE_NOW		"Save Now"
#define TKM_BUTTON_OK			"Ok"
#define TKM_BUTTON_CANCEL		"Cancel"
#define TKM_PREF_SAVE_ON_EXIT		"Save on exit"
#define TKM_PREF_CUSTOM_TITLE		"Custom View"
/* Flags  */

#define TKM_POLL			1	
#define TKM_DISPLAY_WIDTH_ONE           2
#define TKM_DISPLAY_WIDTH_CUSTOM        4
#define TKM_DISPLAY_WIDTH_LARGE		8
#define TKM_DISPLAY_WIDTH_ALL		16
#define TKM_DISPLAY_WIDTH_MASK          (TKM_DISPLAY_WIDTH_ONE | TKM_DISPLAY_WIDTH_CUSTOM | TKM_DISPLAY_WIDTH_LARGE | TKM_DISPLAY_WIDTH_ALL)
#define TKM_DISPLAY_REC                 32
#define TKM_DISPLAY_BAL                 64
#define TKM_DISPLAY_LEFT_PANEL		128
#define TKM_SAVE_ON_EXIT		256
#define TKM_LOUDNESS                    512
#define TKM_ENHANCE                     1024
#define TKM_MUTE                        2048
//#define TKM_TIELR			4096
#define TKM_DISPLAY_DEFAULTVALUE        (TKM_POLL | TKM_DISPLAY_WIDTH_LARGE | TKM_DISPLAY_REC | TKM_DISPLAY_BAL |TKM_DISPLAY_LEFT_PANEL)

//#define TKM_DEFAULT_FLAGS               TKM_POLL
/* was....... TKM_LOUDNESS|TKM_ENHANCE|TKM_MUTE|TKM_POLL */
 

/* macros as they appears in linux's soundcard.h
#define SOUND_MIXER_NRDEVICES   17
#define SOUND_MIXER_VOLUME      0
#define SOUND_MIXER_BASS        1
#define SOUND_MIXER_TREBLE      2
#define SOUND_MIXER_SYNTH       3
#define SOUND_MIXER_PCM         4
#define SOUND_MIXER_SPEAKER     5
#define SOUND_MIXER_LINE        6
#define SOUND_MIXER_MIC         7
#define SOUND_MIXER_CD          8
#define SOUND_MIXER_IMIX        9       //  Recording monitor
#define SOUND_MIXER_ALTPCM      10
#define SOUND_MIXER_RECLEV      11      // Recording level
#define SOUND_MIXER_IGAIN       12      // Input gain
#define SOUND_MIXER_OGAIN       13      // Output gain
#define SOUND_MIXER_LINE1       14      // Input source 1  (aux1)
#define SOUND_MIXER_LINE2       15      // Input source 2  (aux2)
#define SOUND_MIXER_LINE3       16      // Input source 3  (line)
*/


struct itimerval  timer;
struct MixerData {
	int	mixer_fd;
	int     card;
	int	recsrc;
	int	devmask;
	int	recmask;
	int	stereodevs;
	long	flags;
} mix_dat; //_dat_lastpoll;
char	   mixer_device[20];

int        OLD_mix_dat_recsrc ;
//int        TieLR;
Frame      frame,prefFrame;
Panel      mainPanel,leftPanel,rightPanel,prefCustomPanel,prefPanel;
Menu       viewMenu,mainMenu,fullMenu;

int	   menuPopX;
int        device_step_gui; 
int        device_index_gui[20];
int        device_index_custom[21];
Server_image my_bitmap;
Panel_item sliderRec[20];              /*           stores the Rec indicator */
Panel_item sliderLabel[20];            /*                   stores the Label */
Panel_item sliderBal[20];          /*                 stores the Balance */
Panel_item slider[20];                 /*       stores the slider of devices */
int        slider_last_value[20];      /*  stores the last values of devices */
//TODO change variable names slider... to device...

// variables and structures used for the "Preferences" panel
int		pref_selected,pref_custom_gui_step,deviceCustomTemp[21];
Panel_item	pref_custom_deviceViewed[20], pref_custom_view_label,
		pref_ok,pref_cancel,pref_save,
		pref_left,
		pref_save_on_exit;
Server_image	pref_up_arrow,pref_down_arrow,
		pref_custom_deviceIcon[20];

// varibles used for drag and drop
int		DragMsWasUp=FALSE,	// "mouse Btn was pressed" at last event
		DragCanStart=FALSE,	// prevent a drag when adjusting level
		DragXoffset,   		// X offset at start of drag
		DragYoffset;   		// Y offset at start of drag
